{

    Tool to stream MIDI data over TCP/IP or UDP/IP

    Copyright (C) 2003 .. 2008 Blue Hell / Jan Punter :: J.Punter@iaf.nl

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; Version 2 of the License only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

  Modification history :

    2003-02-22 ported to D7 and published

}

unit FrmAbout;

{$WARN UNSAFE_TYPE OFF}
{$WARN UNSAFE_CODE OFF}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFormAbout = class(TForm)
    Panel1: TPanel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    StaticText5: TStaticText;
    StaticText6: TStaticText;
    StaticText7: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    StaticTextCompanyName: TStaticText;
    StaticTextFileDescription: TStaticText;
    StaticTextFileVersion: TStaticText;
    StaticTextInternalName: TStaticText;
    StaticTextLegalCopyRight: TStaticText;
    StaticTextLegalTradeMarks: TStaticText;
    StaticTextOriginalFileName: TStaticText;
    StaticTextProductName: TStaticText;
    StaticTextProductVersion: TStaticText;
    StaticTextComments: TStaticText;
    ImageLogo: TImage;
    procedure FormCreate(Sender: TObject);
    procedure AllClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAbout: TFormAbout;

  Function  GetCompanyName      : String;
  Function  GetFileDescription  : String;
  Function  GetFileVersion      : String;
  Function  GetInternalName     : String;
  Function  GetLegalCopyRight   : String;
  Function  GetLegalTradeMarks  : String;
  Function  GetOriginalFileName : String;
  Function  GetProductName      : String;
  Function  GetProductVersion   : String;
  Function  GetComments         : String;

implementation

{$R *.DFM}

{
  User area
}

// Version information support

Const

  InfoNum  = 10;
  FileInfo : Array[ 1 .. InfoNum] Of String = (
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown',
    'Unknown'
  );

  Function  GetCompanyName      : String;
  Begin
    Result := FileInfo[ 1];
  End;

  Function  GetFileDescription  : String;
  Begin
    Result := FileInfo[ 2];
  End;

  Function  GetFileVersion      : String;
  Begin
    Result := FileInfo[ 3];
  End;

  Function  GetInternalName     : String;
  Begin
    Result := FileInfo[ 4];
  End;

  Function  GetLegalCopyRight   : String;
  Begin
    Result := FileInfo[ 5];
  End;

  Function  GetLegalTradeMarks  : String;
  Begin
    Result := FileInfo[ 6];
  End;

  Function  GetOriginalFileName : String;
  Begin
    Result := FileInfo[ 7];
  End;

  Function  GetProductName      : String;
  Begin
    Result := FileInfo[ 8];
  End;

  Function  GetProductVersion   : String;
  Begin
    Result := FileInfo[ 9];
  End;

  Function  GetComments         : String;
  Begin
    Result := FileInfo[ 10];
  End;

  Procedure InitModule;
  Const
    InfoStr : Array[ 1 .. InfoNum] Of String = (
      'CompanyName',
      'FileDescription',
      'FileVersion',
      'InternalName',
      'LegalCopyRight',
      'LegalTradeMarks',
      'OriginalFileName',
      'ProductName',
      'ProductVersion',
      'Comments'
    );
  Var
    S      : String;
    n      : DWORD;
    Len    : DWORD;
    Buf    : PChar;
    aValue : PChar;
    i      : Integer;
  Begin
    S := Application.ExeName;
    n := GetFileVersionInfoSize( PChar( S), n);
    If n > 0
    Then Begin
      Buf := AllocMem( n);
      Try
        GetFileVersionInfo( PChar( S), 0, n, Buf);
        For i := 1 To InfoNum Do
          If
            VerQueryValue(
              Buf,
              PChar( '\StringFileInfo\040904E4\' + InfoStr[ i]),
              Pointer( aValue),
              Len
            )
          Then FileInfo[ i] := aValue;
      Finally
        FreeMem( Buf, n);
      End;
    End;
  End;


{
  Delphi area
}

procedure TFormAbout.FormCreate(Sender: TObject);
begin
  Color := clBlack;
  StaticTextCompanyName     .Caption := GetCompanyName;
  StaticTextFileDescription .Caption := GetFileDescription;
  StaticTextFileVersion     .Caption := GetFileVersion;
  StaticTextInternalName    .Caption := GetInternalName;
  StaticTextLegalCopyRight  .Caption := GetLegalCopyRight;
  StaticTextLegalTradeMarks .Caption := GetLegalTradeMarks;
  StaticTextOriginalFileName.Caption := GetOriginalFileName;
  StaticTextProductName     .Caption := GetProductName;
  StaticTextProductVersion  .Caption := GetProductVersion;
  StaticTextComments        .Caption := GetComments;
end;

procedure TFormAbout.AllClick(Sender: TObject);
begin
  Close;
end;

procedure TFormAbout.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If ( Shift = []) And (( Key = VK_ESCAPE) Or ( Key = VK_RETURN))
  Then Close;
end;







Initialization
  InitModule;
end.

